function est45000_EmissaoInventario_Controller(ScreenService, General, templateManager, Est45000_EmissaoInventario_Service, ProductField, ZhFilterPreferences) {
 
    this.setNameLayout = function(args){
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
    
    this.openFilter = function(widget){
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            rowsToSet.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            rowsToSet.PRODUTOATIVO = 'T';
            
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function(){
                this.changeFilial(widget);
            }.bind(this));
        }.bind(this));        
    };
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    }; 
	
	this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
	
	//Parâmetros Filtro
    this.changeFilter = function(widget, preference) {
        var filterRow = preference.FILTER_ROW;
        var filtro = [];
        
        if(widget.dataSource.name == 'est_relatorios#/crud/itlanctoest_produto') {
            filtro = [
                {
                    "name": "CDFILIAL",
                    "operator":"=",
                    "value": filterRow.CDFILLANC
                },
                {
                    "name":"NRLANCESTQ",
                    "operator":"=",
                    "value": filterRow.NRLANCESTQ ? filterRow.NRLANCESTQ : null
                }
            ];
        }
        else {
            filtro= [
                {
                    "name": filterRow.CDFILIMOVI? "CDFILIMOVI" : "CDFILIAL",
                    "operator":"=",
                    "value": filterRow.CDFILIMOVI? filterRow.CDFILIMOVI : filterRow.CDFILIAL
                },
                {
                    "name":"CDALMOXARIFE",
                    "operator":"=",
                    "value": filterRow.CDALMOXARIFE ? filterRow.CDALMOXARIFE : null
                },
                {
                    "name":"CDLOCALESTOQ",
                    "operator":"=",
                    "value": filterRow.CDLOCALESTOQ ? filterRow.CDLOCALESTOQ : null
                },
                {
                    "name":"PRODINI",
                    "operator":"=",
                    "value": filterRow.PRODINI ? filterRow.PRODINI : null
                },
                {
                    "name":"PRODFIM",
                    "operator":"=",
                    "value": filterRow.PRODFIM ? filterRow.PRODFIM : null
                },
                {
                    "name":"PRODEST",
                    "operator":"=",
                    "value": filterRow.PRODEST ? filterRow.PRODEST : 'S'
                },
                {
                    "name": "CDGRUPPROD",
                    "operator": "=",
                    "value": filterRow.CDGRUPPROD ? filterRow.CDGRUPPROD : null
                },
                {
                    "name": "NMGRUPPROD",
                    "operator": "=",
                    "value": filterRow.NMGRUPPROD ? filterRow.NMGRUPPROD : null
                },
                {
                    "name": "PRODUTOATIVO",
                    "operator": "=",
                    "value": filterRow.PRODUTOATIVO != 'T' ? filterRow.PRODUTOATIVO : null
                }
            ];
            
            filtro.map(filter=>{
                if(filter.name == "PRODUTOATIVO" && filter.value == null)
                    filtro.pop(filter);
            });
        }
        widget.dataSourceFilter = filtro;
        widget.reload();
        
    };
    
    // Habilita/Desabilita Almoxarifado
    this.changeFilial = function (widget) {
        var cdfilial = widget.currentRow.CDFILIAL;

        if(cdfilial) {
            Est45000_EmissaoInventario_Service.getParamFilial(cdfilial).then(function (paramfilial) {
                widget.getField("DSALMOXARIFE").readOnly = !((paramfilial.dataset.paramfilial[0].IDCTRLESTQ == 'S') && (paramfilial.dataset.paramfilial[0].IDUTILALMOX  == 'S'));
                
                widget.getField("DSALMOXARIFE").dataSourceFilter[0].value = cdfilial;
                widget.getField("DSALMOXARIFE").reload();
                
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }else{
            widget.getField("DSALMOXARIFE").readOnly = true;
            widget.getField("DSLOCALESTOQ").readOnly = true;
        }
        widget.currentRow.DSALMOXARIFE = '';
        widget.currentRow.DSLOCALESTOQ = '';
    };

    // Habilita/Desabilita Localização
    this.changeAlmoxarifado = function (args) {
        var cdfilial     = args.row.CDFILIAL;
        var cdalmoxarife = args.row.CDALMOXARIFE;
        if(cdfilial && cdalmoxarife) {
            Est45000_EmissaoInventario_Service.getParamFilial(cdfilial).then(function (paramfilial) {
                args.owner.field.widget.getField("DSLOCALESTOQ").readOnly = !((paramfilial.dataset.paramfilial[0].IDCTRLESTQ == 'S') && (paramfilial.dataset.paramfilial[0].IDUTILLCESTQ == 'S'));
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }else{
            args.owner.field.widget.getField("DSLOCALESTOQ").readOnly = true;
        }
        args.row.DSLOCALESTOQ = '';
    };
    
    this.habilitaNumLancamento = function(args){
        // var widget = templateManager.container.getWidget('EmissaoInventarioGrid');
        if(args.row.DTLANCESTQ != ""){
            args.owner.field.widget.getField('NRLANCESTQ').readOnly = false;
            args.owner.field.widget.getField('NMPRODINI').readOnly = true;
            args.owner.field.widget.getField('NMPRODINI').setValue('');
            args.owner.field.widget.getField('NMPRODFIM').readOnly = true;
            args.owner.field.widget.getField('NMPRODFIM').setValue('');
            args.owner.field.widget.getField('PRODEST').readOnly = true;
            
            args.owner.field.widget.getField('NRLANCESTQ').validations = {required: true};
            args.owner.field.widget.getField('NMPRODINI').validations = {};
            args.owner.field.widget.getField('NMPRODFIM').validations = {};
            args.owner.field.widget.getField('PRODEST').validations = {};
            this.changeFilterLancEstoq(args);
        }else{
            args.owner.field.widget.getField('NRLANCESTQ').readOnly = true;
            args.owner.field.widget.getField('NMPRODINI').readOnly = false;
            args.owner.field.widget.getField('NMPRODFIM').readOnly = false;
            args.owner.field.widget.getField('PRODEST').readOnly = false;
            
            args.owner.field.widget.getField('NRLANCESTQ').validations = {};
            args.owner.field.widget.getField('NMPRODINI').validations = {required: true};
            args.owner.field.widget.getField('NMPRODFIM').validations = {required: true};
            args.owner.field.widget.getField('PRODEST').validations = {required: true};
            args.owner.field.widget.getField('NRLANCESTQ').setValue('');
            
            this.changeFilterLancEstoq(args);
            args.owner.field.widget.getField('NRLANCESTQ').reload();
        }
    };
    
    this.changeFilterLancEstoq = function(args){
        var cdfilial = args.owner.field.widget.currentRow.CDFILIAL;   
        var dtlancestq = args.owner.field.widget.currentRow.DTLANCESTQ;   
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[0].value = cdfilial;
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[1].value = dtlancestq;
        if(dtlancestq != "" && dtlancestq != undefined){
            args.owner.field.widget.getField('NRLANCESTQ').reload();
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/crud/itlanctoest_produto";
        }else{
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/produto_posestatu_paramfilial";
            delete args.owner.field.widget.currentRow.CDFILIMOVI;
        }
    };
    
    this.changeFilterLancEstoqByFilial = function(args){
        var cdfilial = args.owner.field.widget.currentRow.CDFILIAL;   
        var dtlancestq = args.owner.field.widget.currentRow.DTLANCESTQ;   
        
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[0].value = cdfilial;
        args.owner.field.widget.getField('NRLANCESTQ').dataSourceFilter[1].value = dtlancestq;
        args.owner.field.widget.currentRow.NRLANCESTQ = "";
        if(dtlancestq != ""  && dtlancestq != undefined){
            args.owner.field.widget.getField('NRLANCESTQ').reload();
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/crud/itlanctoest_produto";
        }else{
            templateManager.container.getWidget('EmissaoInventarioGrid').dataSource.name = "est_relatorios#/produto_posestatu_paramfilial";
            delete args.owner.field.widget.currentRow.CDFILIMOVI;
        }
    };

}

Configuration(function(ContextRegister) {
	ContextRegister.register('Est45000_EmissaoInventario_Controller', est45000_EmissaoInventario_Controller);
});
